#include <graphics.h>
#include <dos.h>
#include <stdio.h>
#include "definiri.h"

extern far double *Vector(int N);
extern far void DealocVector(double *m);
extern far char Clasificare(double var,double inf,double sup,double *procent);
extern far void CalculIesiriBinare(double *p,double *y);
extern far void AfisareIesiri(double *p_out,double *procente,int indicator);

extern far char TipFour;
extern far double *ybin;
extern far double *procente;

double f_trapez(double x,double a,double b,double c)
  {
  if (x<a)
     return(x*0.9/a);
  else
     if (x<b)
	return(0.9);
     else
	if (x<c)
	    return((c-x)/(c-b)*0.9);
	else
	    return(0);
  }



void afiseaza_trapez(int xstsus,int ystsus,int xdrjos,int ydrjos,double Tmax,double *p_in,double *p_out,int NrIntrari,int NrIesiri,double a,double b,double c,double punct1,double punct2,double punct3)
    {
    char ch,sir[30];
    int i;
    double interx,intery;
    double procent;
    double valoare;

	/*se reprezinta grafic functia*/
    procente=Vector(NrIesiri);
    interx=(xdrjos-xstsus)*c/Tmax;
    intery=(ydrjos-ystsus)/1.0;
    setcolor(getmaxcolor());
    setviewport(xstsus,ystsus,xdrjos,ydrjos, 1);
    clearviewport();

    if (TipFour=='t')
       {
       moveto(0,(intery+punct1*intery)/2);
       lineto(interx*a/c,(intery-punct2*intery)/2);
       lineto(interx*b/c,(intery-punct2*intery)/2);
       lineto(interx,(intery+punct3*intery)/2);
       lineto(interx,intery/2);
       lineto(interx*Tmax/c,intery/2);
       }
	/*se calculeaza intrarile*/
    for  (i=0;i<NrIntrari;i++)
	 {
	 valoare=f_trapez(i,a,b,c);
	 if (i<b)
	   {
	   valoare*=1.11111*(punct2+punct1);
	   valoare-=punct1;
	   }
	 else
	   if (i<=c)
	      {
	      valoare*=1.11111*(punct2+punct3);
	      valoare-=punct3;
	      }
	   else
	      valoare=0.0;
	 p_in[i]=valoare;
	 if (TipFour=='t')
	    circle(interx/c*i,(intery-p_in[i]*intery)/2,2);
	 }

    if (TipFour=='f')
	{
	Fourier(NULL,NrIntrari,p_in);
	moveto(0,(intery-p_in[0]*intery)/2);
	for  (i=0;i<NrIntrari;i++)
	     lineto(interx/c*i,(intery-p_in[i]*intery)/2);
	}
    if (TipFour=='c')
	{
	for  (i=0;i<NrIntrari/2;i++)
	   p_in[i+NrIntrari/2]=p_in[i];
	Fourier(NULL,NrIntrari/2,p_in);
	moveto(0,(intery-p_in[0]*intery)/2);
	for  (i=0;i<NrIntrari;i++)
	     lineto(interx/c*i/2,(intery-p_in[i]*intery)/2);
	}
	/*se calculeaza iesirile*/

    ch=Clasificare((punct1+punct2)/a,0.4615/(Tmax-3*NrEsant),2.0/NrEsant,&procent);
    p_out[0]=(ch%2)-0.1;
    p_out[1]=(ch/2)-0.1;
    procente[0]=procent;
    ch=Clasificare(b-a,NrEsant,Tmax-3*NrEsant,&procent);
    p_out[2]=(ch%2)-0.1;
    p_out[3]=(ch/2)-0.1;
    procente[1]=procent;
    ch=Clasificare((punct2+punct3)/(c-b),0.4615/(Tmax-3*NrEsant),2.0/NrEsant,&procent);
    p_out[4]=(ch%2)-0.1;
    p_out[5]=(ch/2)-0.1;
    procente[2]=procent;
    ch=Clasificare(c,3*NrEsant,Tmax,&procent);
    p_out[6]=(ch%2)-0.1;
    p_out[7]=(ch/2)-0.1;
    procente[3]=procent;
    for (i=0;i<8;i++)
	p_out[i]=(p_out[i]>0)?p_out[i]:(-p_out[i]);

      /*Afisare*/
    setviewport(FereastraFolosire, 1);
    procente[4]=0;
    ybin=Vector(NrIesiri);
    CalculIesiriBinare(ybin,p_out);
    AfisareIesiri(ybin,procente,0);
    DealocVector(ybin);
    DealocVector(procente);
    }

void RealizeazaDemo(double *pointer_in,double *pointer_out,int *ni,int *ny,double a,double b,double c,double punct1,double punct2,double punct3)
  {
  int NrIntrari,NrIesiri;
  double Tmax;
  NrIntrari=*ni;
  NrIesiri=*ny;
  if (TipFour=='c')
     Tmax=NrIntrari*0.5;
  else
     Tmax=NrIntrari*1.0;
  afiseaza_trapez(FereastraFunctie,Tmax,pointer_in,pointer_out,NrIntrari,NrIesiri,a,b,c,punct1,punct2,punct3);
  }