#include <alloc.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <dir.h>
#include "definiri.h"

struct Perceptron
  {
  double *XI;      /*intrari in retea*/
  double **WI1p;   /*ponderi precedente intrare-->strat1*/
  double **WI1c;   /*ponderi curente intrare-->strat1*/
  double *T1p;     /*praguri precedente strat1*/
  double *T1c;     /*praguri curente strat1*/
  double *X1;      /*iesiri din stratul 1*/
  double *S1;      /*erori pentru stratul 1*/
  double **W12p;   /*ponderi precedente strat1-->strat2*/
  double **W12c;   /*ponderi curente strat1-->strat2*/
  double *T2p;     /*praguri precedente strat2*/
  double *T2c;     /*praguri curente strat2*/
  double *X2;      /*iesiri din stratul 2*/
  double *S2;      /*erori pentru stratul 2*/
  double **W2Yp;   /*ponderi precedente strat2-->iesire*/
  double **W2Yc;   /*ponderi curente strat2-->iesire*/
  double *TYp;     /*praguri precedente strat de iesire*/
  double *TYc;     /*praguri curente strat de iesire*/
  double *Y;       /*iesiri din retea*/
  double *SY;      /*erori pentru stratul de iesire*/
  double *D;       /*iesiri din retea dorite*/
  } P;




extern far void RealizeazaExemplar(double *pointer_in,double *pointer_out,int *NrIntr,int *NrIesiri);
extern far void RealizeazaDemo(double *pointer_in,double *pointer_out,int *ni,int *ny,double a,double b,double c,double punct1,double punct2,double punct3);
extern far void AfisareIesiri(double *p_out,double *procente,int indicator);
extern far void Ecran(void);
extern far void Urmarire(void);
extern far void CitesteSir(char *sir_util,int dimens);
extern far long CitesteInt(void);
extern far double CitesteDouble(void);
extern far char CitesteFisier(char ext[MAXFILE+MAXEXT+1],char i,char *j);


double **Matrice(int M,int N);
double *Vector(int N);
void 	DealocMatrice(double **m,int M);
void 	DealocVector(double *v);
long    MemV(int N);
long    MemM(int M,int N);
long	MemDisp(void);
void AlocaRetea(void);
void DeAlocaRetea(void);
void CitesteValoriUtilizator(void);
void CitesteValoriDisc(char p[]);
void AfisareParametri(void);
void InitializarePonderi(void);
void CitestePonderi(void);
void CalculIesiri(void);
void Antrenare(void);
void ScrieFisier(char p[]);

double *Exemplar;
double *IesireDorita;
double **tab;
double *procente;
double *ybin;
void *ImgSalvMeniu;
void *ImgSalvSubMeniu;
void *ImgSalvFis;
void *ImgSalvNume;
void *ImgSalvAnal;
void *ImgSalvAnalNume;
unsigned char *semnal_temp;
char *buff_temp;
float *t_real;
float *t_imag;
int *put_2;

int NI,N1,N2,NY,indicator=0,indice;
int numar_1us=3;
char eroare=NuExista;
double ALFA,ETA;
long NrPasi,PasiRealiz;
FILE *pfis,*pfis_list;
extern far char optim;
extern far char simulare;
extern far char autosave;
extern far char TipFour;
char sir2[50];
char cale[MAXPATH];
char disc[MAXDRIVE];
char dir[MAXDIR];
char nume_fisier[MAXFILE+MAXEXT-1];
char ext[MAXEXT];

/*----------------------------------------------------*/

double **Matrice(int M,int N)
  {
  int i;
  double **m;
  m=(double **) farmalloc ((unsigned) M*sizeof(double*));
  if (!m)
	{
	eroare=Exista;
	return m;
	}
  for(i=0;i<M;i++)
	{
	m[i]=(double *) farmalloc((unsigned) N*sizeof(double));
	if (!m[i])
	   eroare=Exista;;
	}
  return m;
  }
/*----------------------------------------------------*/
double *Vector(int N)
  {
  double *v;
  v=(double *) farmalloc((unsigned) N*sizeof(double));
  if (!v)
     eroare=Exista;
  return v;
  }
/*----------------------------------------------------*/
void *Imagine(unsigned dim)
   {
   void *v;
   v=farmalloc(dim);
   if (!v)
     {
     printf("eroare de alocare de vector");
     exit(1);
     }
   return v;
   }

void DealocMatrice(double **m,int M)
  {
  int i;
  if (m)
    for (i=0;i<M;i++)
       if (m[i])
	 farfree(m[i]);
  if (m)
     farfree(m);
  }
/*----------------------------------------------------*/
void DealocVector(double *v)
  {
  if (v)
    farfree(v);
  }
/*----------------------------------------------------*/
void DealocImagine(void *v)
  {
  farfree(v);
  }

long MemV(int N)
  {
  long L;
  L=N*sizeof(double)+sizeof(double *);
  return(L);
  }
/*----------------------------------------------------*/
long MemM(int M,int N)
  {
  long L;
  L=M*(N*sizeof(double)+sizeof(double *))+sizeof(double **);
  return(L);
  }
/*----------------------------------------------------*/
long MemDisp(void)
  {
  long L;
  L=farcoreleft();
  return(L);
  }
/*----------------------------------------------------*/
void AlocaRetea(void)
  {
  Exemplar=Vector(NI);
  IesireDorita=Vector(NY);
  P.XI=Vector(NI);
  P.WI1p=Matrice(NI,N1);
  P.WI1c=Matrice(NI,N1);
  P.T1p=Vector(N1);
  P.T1c=Vector(N1);
  P.X1=Vector(N1);
  P.S1=Vector(N1);
  P.W12p=Matrice(N1,N2);
  P.W12c=Matrice(N1,N2);
  P.T2p=Vector(N2);
  P.T2c=Vector(N2);
  P.X2=Vector(N2);
  P.S2=Vector(N2);
  P.W2Yp=Matrice(N2,NY);
  P.W2Yc=Matrice(N2,NY);
  P.TYp=Vector(NY);
  P.TYc=Vector(NY);
  P.Y=Vector(NY);
  P.SY=Vector(NY);
  P.D=Vector(NY);
  }

void DeAlocaRetea(void)
  {
  DealocVector(P.D);
  DealocVector(P.SY);
  DealocVector(P.Y);
  DealocVector(P.TYc);
  DealocVector(P.TYp);
  DealocMatrice(P.W2Yc,N2);
  DealocMatrice(P.W2Yp,N2);
  DealocVector(P.S2);
  DealocVector(P.X2);
  DealocVector(P.T2c);
  DealocVector(P.T2p);
  DealocMatrice(P.W12c,N1);
  DealocMatrice(P.W12p,N1);
  DealocVector(P.S1);
  DealocVector(P.X1);
  DealocVector(P.T1c);
  DealocVector(P.T1p);
  DealocMatrice(P.WI1c,NI);
  DealocMatrice(P.WI1p,NI);
  DealocVector(P.XI);
  DealocVector(IesireDorita);
  DealocVector(Exemplar);
  }

void ModificaParametri()
  {
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  setcolor(getmaxcolor());
  ALFA=0;
  while ((ALFA<=0)||(ALFA>=1))
     {
     bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
     outtextxy(20,getmaxy()-19,"Parametrul Alfa :");
     ALFA=CitesteDouble();
     }
  ETA=0;
  while ((ETA<=0)||(ETA>=1))
     {
     bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
     outtextxy(20,getmaxy()-19,"Parametrul Eta :");
     ETA=CitesteDouble();
     }
  }

void CitesteValoriUtilizator(void)
  {
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  setcolor(getmaxcolor());
  outtextxy(20,getmaxy()-19,"Numarul de intrari :");
  NI=CitesteInt();
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Numarul de neuroni de pe stratul 1 :");
  N1=CitesteInt();
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Numarul de neuroni de pe stratul 2 :");
  N2=CitesteInt();
  NY=7;
  while (NY<11)
    {
    bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
    outtextxy(20,getmaxy()-19,"Numarul de iesiri (minim 11) :");
    NY=CitesteInt();
    }
  ALFA=0;
  while ((ALFA<=0)||(ALFA>=1))
     {
     bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
     outtextxy(20,getmaxy()-19,"Parametrul Alfa :");
     ALFA=CitesteDouble();
     }
  ETA=0;
  while ((ETA<=0)||(ETA>=1))
     {
     bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
     outtextxy(20,getmaxy()-19,"Parametrul Eta :");
     ETA=CitesteDouble();
     }
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  }


void InitializarePonderi(void)
  {
  int i,j;
  for (i=0;i<NI;i++)
     for (j=0;j<N1;j++)
	P.WI1p[i][j]=P.WI1c[i][j]=random(32767)/32767.0-0.5;
  for (i=0;i<N1;i++)
	P.T1p[i]=P.T1c[i]=random(32767)/32767.0-0.5;
  for (i=0;i<N1;i++)
     for (j=0;j<N2;j++)
	P.W12p[i][j]=P.W12c[i][j]=random(32767)/32767.0-0.5;
  for (i=0;i<N2;i++)
	P.T2p[i]=P.T2c[i]=random(32767)/32767.0-0.5;
  for (i=0;i<N2;i++)
     for (j=0;j<NY;j++)
	P.W2Yp[i][j]=P.W2Yc[i][j]=random(32767)/32767.0-0.5;
  for (i=0;i<NY;i++)
	P.TYp[i]=P.TYc[i]=random(32767)/32767.0-0.5;
  }

void AfisareParametri(void)
  {
  char sir[10];
  int culoare;
  culoare=getbkcolor();
  setfillstyle(SOLID_FILL,culoare);
  bar(getmaxx()-140,par+79,getmaxx()-7,par+89);
  bar(getmaxx()-40,par+9,getmaxx()-7,par+69);
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  setcolor(getmaxcolor());
  sprintf(sir,"%4d",NI);
  outtextxy(getmaxx()-50,par+10,sir);
  sprintf(sir,"%4d",NY);
  outtextxy(getmaxx()-50,par+20,sir);
  sprintf(sir,"%4d",N1);
  outtextxy(getmaxx()-50,par+30,sir);
  sprintf(sir,"%4d",N2);
  outtextxy(getmaxx()-50,par+40,sir);
  sprintf(sir,"%3.2f",ALFA);
  outtextxy(getmaxx()-50,par+50,sir);
  sprintf(sir,"%3.2f",ETA);
  outtextxy(getmaxx()-50,par+60,sir);
  sprintf(sir,"%6ld",PasiRealiz);
  outtextxy(getmaxx()-80,par+80,sir);
  }

void CalculIesiriBinare(double *p,double *y)
  {
  int i,j;
  for (i=0;i<NY;i++)
      {
      j=y[i]*10;
      p[i]=(j<5)?0:1;
      }
  }

void AplicaIntrare(int indicator)
  {
  int i;
  if (indicator)
     RealizeazaExemplar(Exemplar,IesireDorita,&NI,&NY);
  for (i=0;i<NI;i++)
     P.XI[i]=Exemplar[i];
  CalculIesiri();
  CalculIesiriBinare(P.SY,P.Y);
  AfisareIesiri(P.SY,P.Y,1);
  }

void CalculIesiri(void)
  {
  int i,j;
	for (j=0;j<N1;j++)
	   {
	   for (i=0,P.X1[j]=0.0;i<NI;i++)
	      P.X1[j]+=P.WI1c[i][j]*P.XI[i];
	   P.X1[j]=1.0/(1.0+exp(-P.T1c[j]-P.X1[j]));
	   }
	for (j=0;j<N2;j++)
	   {
	   for (i=0,P.X2[j]=0.0;i<N1;i++)
	      P.X2[j]+=P.W12c[i][j]*P.X1[i];
	   P.X2[j]=1.0/(1.0+exp(-P.T2c[j]-P.X2[j]));
	   }
	for (j=0;j<NY;j++)
	   {
	   for (i=0,P.Y[j]=0.0;i<N2;i++)
	      P.Y[j]+=P.W2Yc[i][j]*P.X2[i];
	   P.Y[j]=1.0/(1.0+exp(-P.TYc[j]-P.Y[j]));
	   }
  }


void Antrenare(void)
  {
  int i,j;
  long k;
  double temp;
  double Err,ErrMed;
  double coada[100];
  char c=5,sir[10],sir1[30];
  if (indicator!=1)
     {
       sound(1000);
       delay(200);
       nosound();
       outtextxy(50,getmaxy()-19,"Definiti mai intai o retea !!");
       return;
       }
  if ((TipFour=='f')||(TipFour=='c'))
     {
     i=0;
     j=0;
     while((j==0)&&(i<10))
	 {
	 k=pow(2,i);
	 i++;
	 if (k==NI)
	    j=1;
	 }
     if (j==0)
	{
	sound(1000);
	delay(200);
	nosound();
	outtextxy(50,getmaxy()-19,"Numarul de intrari nu este putere a lui 2 !!");
	return;
	}
     }
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Numarul de pasi de antrenare :");
  NrPasi=CitesteInt();
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  if (autosave=='y')
     {
     outtextxy(20,getmaxy()-19,"Fisierul pentru salvare :");
     if (CitesteFisier("*.ret",Save,&c)==27)
	return;
     }
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Reteaua se antreneaza ! Apasati ESC pentru a opri");
  setfillstyle(SOLID_FILL,getbkcolor());
  bar(FereastraAntrenare);
  setcolor(getmaxcolor());
  setviewport(FereastraAntrenare,1);
  rectangle(ChenarAntrenare);
  sprintf(sir1,"Numarul de pasi :  %6ld",NrPasi);
  outtextxy(5,5,sir1);
  if (autosave=='y')
     {
     pfis_list=NULL;
     fnsplit(cale,disc,dir,nume_fisier,ext);
     strcat(nume_fisier,".rez");
     pfis_list=fopen(nume_fisier,"at");
     fprintf(pfis_list, "Parametrul ALFA %f \n",ALFA);
     fprintf(pfis_list, "           ETA  %f \n",ETA);
     }
  for (k=1,indice=0,ErrMed=0;k<=NrPasi;k++)
     {
	RealizeazaExemplar(Exemplar,IesireDorita,&NI,&NY);
	if (eroare==Exista)
	   {
	   setviewport(0,0,getmaxx(),getmaxy(),1);
	   bar(BaraStare);
	   outtextxy(PozMesaj,"Nu se poate realiza");
	   sound(1000);
	   delay(200);
	   nosound();
	   eroare=NuExista;
	   return;
	   }
	for (i=0;i<NI;i++)
	   P.XI[i]=Exemplar[i];
	for (i=0;i<NY;i++)
	   P.D[i]=IesireDorita[i];
	/*s-au aplicat intrarile si iesirile dorite*/

	CalculIesiri();

	for (j=0;j<NY;j++)
	    P.SY[j]=P.Y[j]*(1.0-P.Y[j])*(P.D[j]-P.Y[j]);
	/*s-au calculat erorile stratului de iesire*/

	for (j=0;j<NY;j++)
	   {
	   for (i=0;i<N2;i++)
	      {
	      temp=P.W2Yc[i][j];
	      P.W2Yc[i][j]+=ETA*P.SY[j]*P.X2[i]+ALFA*(P.W2Yc[i][j]-P.W2Yp[i][j]);
	      P.W2Yp[i][j]=temp;
	      }
	   temp=P.TYc[j];
	   P.TYc[j]+=ETA*P.SY[j]+ALFA*(P.TYc[j]-P.TYp[j]);
	   P.TYp[j]=temp;
	   }
	/*s-au adaptat ponderile si pragurile stratului de iesire*/

	for (i=0;i<N2;i++)
	   {
	   for (j=0,P.S2[i]=0.0;j<NY;j++)
	      P.S2[i]+=P.W2Yp[i][j]*P.SY[j];
	   P.S2[i]*=P.X2[i]*(1.0-P.X2[i]);
	   }
	/*s-au calculat erorile stratului 2*/

	for (j=0;j<N2;j++)
	   {
	   for (i=0;i<N1;i++)
	      {
	      temp=P.W12c[i][j];
	      P.W12c[i][j]+=ETA*P.S2[j]*P.X1[i]+ALFA*(P.W12c[i][j]-P.W12p[i][j]);
	      P.W12p[i][j]=temp;
	      }
	   temp=P.T2c[j];
	   P.T2c[j]+=ETA*P.S2[j]+ALFA*(P.T2c[j]-P.T2p[j]);
	   P.T2p[j]=temp;
	   }
	/*s-au adaptat ponderile si pragurile stratului 2*/

	for (i=0;i<N1;i++)
	   {
	   for (j=0,P.S1[i]=0.0;j<N2;j++)
	      P.S1[i]+=P.W12p[i][j]*P.S2[j];
	   P.S1[i]*=P.X1[i]*(1.0-P.X1[i]);
	   }
	/*s-au calculat erorile stratului 1*/

	for (j=0;j<N1;j++)
	   {
	   for (i=0;i<NI;i++)
	      {
	      temp=P.WI1c[i][j];
	      P.WI1c[i][j]+=ETA*P.S1[j]*P.XI[i]+ALFA*(P.WI1c[i][j]-P.WI1p[i][j]);
	      P.WI1p[i][j]=temp;
	      }
	   temp=P.T1c[j];
	   P.T1c[j]+=ETA*P.S1[j]+ALFA*(P.T1c[j]-P.T1p[j]);
	   P.T1p[j]=temp;
	   }
	/*s-au adaptat ponderile si pragurile stratului 1*/

	setviewport(FereastraAntrenare,1);
	setfillstyle(SOLID_FILL,getbkcolor());
	bar(5,14,230,24);
	setcolor(getmaxcolor());
	sprintf(sir1,"Parcurs :          %6ld",k);
	outtextxy(5,15,sir1);
	if (optim=='c')
	   {
	   for (j=0;j<NY;j++)
	       {
	       if (P.Y[j]>0.5)
		  P.SY[j]=0.9;
	       else
		  P.SY[j]=0.1;
	       }
	   for (j=0,Err=0;j<NY;j++)
	      Err+=(P.D[j]-P.SY[j])*(P.D[j]-P.SY[j])/NY;
	   bar(5,24,230,34);
	   sprintf(sir1,"Eroare Momentana : %6.3lf",Err);
	   outtextxy(5,25,sir1);
	   if (k<=100)
	      {
	      coada[indice]=Err;
	      ErrMed=ErrMed*indice+Err;
	      indice++;
	      ErrMed/=indice;
	      }
	   else
	      {
	      if (indice>=100)
		 indice=0;
	      ErrMed-=coada[indice]/100.0;
	      ErrMed+=Err/100.0;
	      coada[indice++]=Err;
	      }
	   bar(5,34,230,44);
	   sprintf(sir1,"Eroare Medie :     %6.3lf",ErrMed);
	   outtextxy(5,35,sir1);
	   }
	if ((k%200==0)&&(autosave=='y'))
	   {
	   if (pfis_list!=NULL)
		{
		fprintf(pfis_list, "%ld \n",k+PasiRealiz);
		fprintf(pfis_list, "%5.4f \n\n",ErrMed);
		}
	   }
	if ((k%1000==0)&&(autosave=='y'))
	   ScrieFisier(cale);
	if (kbhit())
	   {
	   c=getch();
	   if (c==27)
	      {
	      PasiRealiz+=k-NrPasi;
	      k=NrPasi;
	      }
	   }
     }
  PasiRealiz+=k;
  if (autosave=='y')
     ScrieFisier(cale);
  clearviewport();
  fclose(pfis_list);
  setviewport(Fereastra2,1);
  clearviewport();
  setviewport(FereastraFunctie,1);
  clearviewport();
  setviewport(0,0,getmaxx(),getmaxy(),1);
  setfillstyle(SOLID_FILL,getbkcolor());
  bar(getmaxx()-148,par+79,getmaxx()-7,par+89);
  sprintf(sir,"%6ld",PasiRealiz);
  outtextxy(getmaxx()-80,par+80,sir);
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  }




void ScrieFisier(char cale[])
  {
  int i;
  if ((pfis=fopen(cale,"wb"))==NULL)
     {
     sound(1000);
     delay(200);
     nosound();
     outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
     return;
     }
  fwrite(&NI,sizeof(int),1,pfis);
  fwrite(&N1,sizeof(int),1,pfis);
  fwrite(&N2,sizeof(int),1,pfis);
  fwrite(&NY,sizeof(int),1,pfis);
  fwrite(&ALFA,sizeof(double),1,pfis);
  fwrite(&ETA,sizeof(double),1,pfis);
  fwrite(&PasiRealiz,sizeof(long),1,pfis);
  for (i=0;i<NI;i++)
	fwrite(P.WI1c[i],sizeof(double),N1,pfis);
  for (i=0;i<NI;i++)
	fwrite(P.WI1p[i],sizeof(double),N1,pfis);
  fwrite(P.T1c,sizeof(double),N1,pfis);
  fwrite(P.T1p,sizeof(double),N1,pfis);
  for (i=0;i<N1;i++)
	fwrite(P.W12c[i],sizeof(double),N2,pfis);
  for (i=0;i<N1;i++)
	fwrite(P.W12p[i],sizeof(double),N2,pfis);
  fwrite(P.T2c,sizeof(double),N2,pfis);
  fwrite(P.T2p,sizeof(double),N2,pfis);
  for (i=0;i<N2;i++)
	fwrite(P.W2Yc[i],sizeof(double),NY,pfis);
  for (i=0;i<N2;i++)
	fwrite(P.W2Yp[i],sizeof(double),NY,pfis);
  fwrite(P.TYc,sizeof(double),NY,pfis);
  fwrite(P.TYp,sizeof(double),NY,pfis);
  fclose(pfis);
  }

void CitesteValoriDisc(char cale[])
  {
  if ((pfis=fopen(cale,"rb"))==NULL)
     {
     sound(1000);
     delay(200);
     nosound();
     outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
     return;
     }
  fread(&NI,sizeof(int),1,pfis);
  fread(&N1,sizeof(int),1,pfis);
  fread(&N2,sizeof(int),1,pfis);
  fread(&NY,sizeof(int),1,pfis);
  fread(&ALFA,sizeof(double),1,pfis);
  fread(&ETA,sizeof(double),1,pfis);
  fread(&PasiRealiz,sizeof(long),1,pfis);
  }

void CitestePonderi(void)
  {
  int i;
  for (i=0;i<NI;i++)
	fread(P.WI1c[i],sizeof(double),N1,pfis);
  for (i=0;i<NI;i++)
	fread(P.WI1p[i],sizeof(double),N1,pfis);
  fread(P.T1c,sizeof(double),N1,pfis);
  fread(P.T1p,sizeof(double),N1,pfis);
  for (i=0;i<N1;i++)
	fread(P.W12c[i],sizeof(double),N2,pfis);
  for (i=0;i<N1;i++)
	fread(P.W12p[i],sizeof(double),N2,pfis);
  fread(P.T2c,sizeof(double),N2,pfis);
  fread(P.T2p,sizeof(double),N2,pfis);
  for (i=0;i<N2;i++)
	fread(P.W2Yc[i],sizeof(double),NY,pfis);
  for (i=0;i<N2;i++)
	fread(P.W2Yp[i],sizeof(double),NY,pfis);
  fread(P.TYc,sizeof(double),NY,pfis);
  fread(P.TYp,sizeof(double),NY,pfis);
  fclose(pfis);
  }

void Incarcare(void)
    {
    long L1,L2;
    char sir[10];
    if (indicator==1)
       DeAlocaRetea();
    indicator=1;
    CitesteValoriDisc(cale);
    L1=MemDisp();
    L2=MemV(NI)+2*MemM(NI,N1)+4*MemV(N1)+2*MemM(N1,N2)+4*MemV(N2)+2*MemM(N2,NY)+5*MemV(NY)+MemM(NI,1);
    if (L1<L2)
	return;
    AlocaRetea();
    if (eroare==Exista)
       {
       sound(1000);
       delay(200);
       nosound();
       DeAlocaRetea();
       outtextxy(50,getmaxy()-19,"Memorie insuficienta !!");
       eroare=NuExista;
       indicator=0;
       return;
       }
    CitestePonderi();
    AfisareParametri();
    sprintf(sir,"%lu",farcoreleft());
    setfillstyle(SOLID_FILL,getbkcolor());
    bar(getmaxx()-70,optiuni+109,getmaxx()-7,optiuni+119);
    outtextxy(getmaxx()-70,optiuni+110,sir);
    }

void ReteaNoua(void)
    {
    long L1,L2;
    char sir[10];
    if (indicator==1)
       DeAlocaRetea();
    indicator=1;
    CitesteValoriUtilizator();
    L1=MemDisp();
    L2=MemV(NI)+2*MemM(NI,N1)+4*MemV(N1)+2*MemM(N1,N2)+4*MemV(N2)+2*MemM(N2,NY)+5*MemV(NY)+MemM(NI,1);
    if (L1<L2)
	return;
    AlocaRetea();
    if (eroare==Exista)
       {
       sound(1000);
       delay(200);
       nosound();
       DeAlocaRetea();
       outtextxy(50,getmaxy()-19,"Memorie insuficienta !!");
       eroare=NuExista;
       indicator=0;
       return;
       }
    InitializarePonderi();
    PasiRealiz=0;
    AfisareParametri();
    sprintf(sir,"%lu",farcoreleft());
    setfillstyle(SOLID_FILL,getbkcolor());
    bar(getmaxx()-70,optiuni+109,getmaxx()-7,optiuni+119);
    outtextxy(getmaxx()-70,optiuni+110,sir);
    }

void Demo(void)
    {
    double a,b,c;
    char ch,ant_optim;
    int i,j,k,m,n,pas=0,pas_abc;
    unsigned pauza=0;
    setfillstyle(SOLID_FILL,getmaxcolor()/2);
    if (indicator!=1)
       {
       bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
       outtextxy(50,getmaxy()-19,"Definiti mai intai o retea !!");
       return;
       }
    if ((TipFour=='f')||(TipFour=='c'))
     {
     i=0;
     j=0;
     while((j==0)&&(i<10))
	 {
	 k=pow(2,i);
	 i++;
	 if (k==NI)
	    j=1;
	 }
     if (j==0)
	{
	sound(1000);
	delay(200);
	nosound();
	outtextxy(50,getmaxy()-19,"Numarul de intrari nu este putere a lui 2 !!");
	return;
	}
     }
    ant_optim=optim;
    optim='c';
    while ((pauza>10)||(pauza<1))
      {
      bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
      outtextxy(20,getmaxy()-19,"Pauza in secunde (1-10) :");
      pauza=CitesteInt();
      }
    while ((pas>10)||(pas<2))
      {
      bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
      outtextxy(20,getmaxy()-19,"Pasi la fieacare clasa (2-10) :");
      pas=CitesteInt();
      }
    setfillstyle(SOLID_FILL,getmaxcolor()/2);
    bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
    outtextxy(20,getmaxy()-19,"Demonstratie !  ESC pentru oprire");
    pas_abc=(NI-4*NrEsant)/pas;

    setviewport(FereastraFolosire,1);
    clearviewport();
    for (i=NrEsant;i<NI-3*NrEsant;i=i+pas_abc)
	for (j=NrEsant;j<NI-3*NrEsant;j=j+pas_abc)
	    for (k=NrEsant;k<NI-3*NrEsant;k=k+pas_abc)
		{
		a=i;
		b=i+j;
		c=i+j+k;
		if (c>NI)
		   break;
		RealizeazaDemo(Exemplar,IesireDorita,&NI,&NY,a,b,c,0.9,0.9,0.5);
		for (m=0;m<NI;m++)
		    P.XI[m]=Exemplar[m];
		CalculIesiri();
		CalculIesiriBinare(P.SY,P.Y);
		AfisareIesiri(P.SY,P.Y,1);
		delay(pauza*1000);
		if (kbhit())
		   {
		   ch=getch();
		   if (ch==27)
		      goto etich;
		   }
		}
    etich:
    clearviewport();
    setviewport(FereastraFunctie,1);
    clearviewport();
    optim=ant_optim;
    setviewport(0,0,getmaxx(),getmaxy(),1);
    bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
    }

void Folosire(void)
    {
    int i,j,k;
    char ant_optim;
    if (indicator!=1)
       {
       sound(1000);
       delay(200);
       nosound();
       outtextxy(50,getmaxy()-19,"Definiti mai intai o retea !!");
       return;
       }
    if ((TipFour=='f')||(TipFour=='c'))
     {
     i=0;
     j=0;
     while((j==0)&&(i<10))
	 {
	 k=pow(2,i);
	 i++;
	 if (k==NI)
	    j=1;
	 }
     if (j==0)
	{
	sound(1000);
	delay(200);
	nosound();
	outtextxy(50,getmaxy()-19,"Numarul de intrari nu este putere a lui 2 !!");
	return;
	}
     }
    ant_optim=optim;
    optim='c';
    setfillstyle(SOLID_FILL,getmaxcolor()/2);
    bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
    outtextxy(20,getmaxy()-19,"Folosire !  ESC/orice pentru oprire/continuare");
    setviewport(FereastraFolosire,1);
    while (getch()!=27)
       AplicaIntrare(1);
    clearviewport();
    setviewport(FereastraFunctie,1);
    clearviewport();
    setviewport(0,0,getmaxx(),getmaxy(),1);
    bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
    optim=ant_optim;
    }

main()
 {
 int i,gdriver = DETECT, gmode, errorcode;
 char c;
 time_t t;
 clrscr();
 srand((unsigned) time(&t));


errorcode = registerbgidriver(EGAVGA_driver);
if (errorcode < 0)
{
   sound(1000);
   delay(200);
   nosound();
   printf("Eroare Grafica : %s\n", grapherrormsg(errorcode));
   printf("Orice pentru a iesi:");
   getch();
   exit(1);
}
initgraph(&gdriver, &gmode, "");
errorcode = graphresult();
if (errorcode != grOk)
{
   sound(1000);
   delay(200);
   nosound();
   printf("Eroare Grafica : %s\n", grapherrormsg(errorcode));
   printf("Orice pentru a iesi:");
   getch();
   exit(1);
}


 pfis=fopen("nr.lab","rb");
 fread(&i,sizeof(char),1,pfis);
 settextjustify(CENTER_TEXT, CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 setcolor(RED);
 outtextxy(getmaxx()/2,getmaxy()/2-100,"Tehnici neuronale si");
 setcolor(YELLOW);
 outtextxy(getmaxx()/2,getmaxy()/2-75,"de inteligenta artificiala");
 setcolor(BLUE);
 outtextxy(getmaxx()/2,getmaxy()/2-50,"in prelucrarea semnalului respirator");
 settextjustify(LEFT_TEXT, BOTTOM_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(WHITE);
 sprintf(sir2,"Lucrare de laborator nr. %c",i);
 outtextxy(getmaxx()/2-150,getmaxy()/2+30,sir2);
 outtextxy(getmaxx()/2-150,getmaxy()/2+100,"Realizator  : Stud. Damian Radu");
 outtextxy(getmaxx()/2-150,getmaxy()/2+120,"Coordonator : Prof. H.N.Teodorescu");
 getch();
 cleardevice();
 Ecran();
 strcpy(dir, "X:\\");
 dir[0] = 'A' + getdisk();
 getcurdir(0, dir+3);
 if (strlen(dir)==3)
	dir[2]=0;
 setcolor(getmaxcolor());
 Urmarire();
 if (indicator==1)
    DeAlocaRetea();
 closegraph();
 exit(0);
 return 0;
 }
